<template>
    <div v-if="id">
        <router-link
            tag="button"
            class="uk-button uk-button-default uk-align-right uk-margin-small-top uk-margin-small-left"
            :to="{
                name: 'ModificationLecon',
                params: { id: id }
            }"
        >
            Modifier
        </router-link>

        <div class="uk-inline uk-align-right uk-margin-small-top">
            <button class="uk-button uk-button-default" type="button">
                <span> Ajouter exercice</span
                ><span uk-icon="icon:  triangle-down"></span>
            </button>
            <div
                uk-dropdown="mode: click; boundary: ! .uk-button-group; boundary-align: true;"
            >
                <ul class="uk-nav uk-dropdown-nav">
                    <li class="uk-active">
                        <router-link
                            tag="a"
                            :to="{
                                name: 'CreationProbleme',
                                params: { idLecon: id }
                            }"
                        >
                            Editeur
                        </router-link>
                    </li>
                    <li class="uk-active">
                        <a uk-toggle="target: #importMasse">Masse</a>
                    </li>
                </ul>
            </div>
        </div>

        <div id="importMasse" uk-modal>
            <div class="uk-modal-dialog uk-modal-body">
                <ImportMasse
                    :idLecon="id"
                    @ajouterProblemes="ajouterProblemes"
                />
            </div>
        </div>

        <h1 style="margin-top:0px">{{ titre }}</h1>
        <div class="uk-text-bold">
            <div>{{ niveau }}</div>
            <div>Créé par : {{ createur }}</div>
            <span>
                Privé
            </span>
            <input
                class="uk-checkbox"
                type="checkbox"
                v-model="prive"
                disabled="disabled"
            />
        </div>
        <h3 class="uk-heading-line">
            <span>Explications</span>
        </h3>
        <div class="texte-lecon" v-html="getTexte()" />

        <ListeExercices
            v-if="id"
            :titre="'Illustration cours'"
            :exercicesCharges="explications"
            :idLecon="id"
            :typeExercice="'EXPLICATIONS'"
            :affectationAutorisee="false"
        />

        <ListeExercices
            v-if="id"
            :titre="'Exercices'"
            :exercicesCharges="exercices"
            :idLecon="id"
            :typeExercice="'EXERCICES'"
            :affectationAutorisee="true"
        />

        <h3 class="uk-heading-line">Eleves ayant eu la leçon</h3>
        <div v-if="eleves.length > 0">
            <table class="uk-table uk-table-divider uk-table-small">
                <tr v-for="eleve in eleves" :key="eleve.id">
                    <td>
                        {{ eleve.nom }}
                        {{ eleve.prenom }}
                    </td>
                </tr>
            </table>
        </div>
        <div v-else>Pas d'élèves pour l'instant</div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import Axios from '@/auth/axiosAuth';
import ListeExercices from './ListeExercices.vue';
import TraductionLexique from '@/components/outils/TraductionLexique';
import ImportMasse from '@/views/Enseignement/lecon/importmasse/ImportMasse.vue';
import Probleme from '@/classes/Probleme';
import * as TypeProbleme from '@/components/constantes/TypeDeProbleme';

@Component({
    components: { ListeExercices, ImportMasse }
})
export default class VisualisationLecon extends Vue {
    private titre = '';
    private niveau = '';
    private texte = '';
    private prive = false;
    private id = '';
    private exercices: any[] = [];
    private explications: any[] = [];
    private eleves: any[] = [];
    private createur: '';

    beforeRouteEnter(to, from, next) {
        next(vm => {
            const data = new FormData();
            data.append('id', to.params.id);
            data.append('idClub', vm.$auth.user.idClub);
            Axios.post(
                'lecon/',
                response => {
                    const lecon = response.data;
                    vm.titre = lecon.titre;
                    vm.niveau = lecon.niveau;
                    vm.texte = lecon.texte;
                    vm.prive = lecon.prive;
                    vm.exercices = lecon.exercicesEntrainement.sort(function(
                        a,
                        b
                    ) {
                        return a.ordre - b.ordre;
                    });
                    vm.explications = lecon.exercicesCours.sort(function(a, b) {
                        return a.ordre - b.ordre;
                    });
                    vm.eleves = lecon.eleves;
                    vm.id = to.params.id;
                    vm.createur = lecon.createur.nomComplet;
                },
                data
            );
        });
    }

    private getTexte(): string {
        return TraductionLexique.expliquerLexique(this.texte);
    }

    private ajouterProblemes(problemes: Probleme[]) {
        problemes.forEach(probleme => {
            if (probleme.getTypeProbleme() === TypeProbleme.PRESENTATION) {
                this.explications.push(probleme);
            } else {
                this.exercices.push(probleme);
            }
        });
    }
}
</script>
<style lang="scss" scoped>
.texte-lecon .uk-inline {
    vertical-align: baseline;
}
.uk-modal-dialog {
    width: 60%;
}
</style>
